//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  DarkOrange
#property indicator_color4  DarkOrange
#property indicator_color5  Silver
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern int    FastPeriod    = 12;
extern double FastDivisor   =  2;
extern int    SlowPeriod    = 26;
extern double SlowDivisor   =  2;
extern int    SignalPeriod  =  9;
extern double SignalDivisor = 1.5;
extern int    Price         = PRICE_CLOSE;
extern bool   Interpolate   = true;

//
//
//
//
//

double macduu[];
double macdud[];
double macddd[];
double macddu[];
double macd[];
double signal[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,macduu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macddd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,macddu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);   
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" MACD hull variation ("+FastPeriod+","+SlowPeriod+","+SignalPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { macduu[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  macduu[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastPeriod,FastDivisor,SlowPeriod,SlowDivisor,SignalPeriod,SignalDivisor,Price,0,y);
                  macdud[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastPeriod,FastDivisor,SlowPeriod,SlowDivisor,SignalPeriod,SignalDivisor,Price,1,y);
                  macddd[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastPeriod,FastDivisor,SlowPeriod,SlowDivisor,SignalPeriod,SignalDivisor,Price,2,y);
                  macddu[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastPeriod,FastDivisor,SlowPeriod,SlowDivisor,SignalPeriod,SignalDivisor,Price,3,y);
                  macd[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",FastPeriod,FastDivisor,SlowPeriod,SlowDivisor,SignalPeriod,SignalDivisor,Price,4,y);
                  signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastPeriod,FastDivisor,SlowPeriod,SlowDivisor,SignalPeriod,SignalDivisor,Price,5,y);
                     
                  if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                  //
                  //
                  //
                  //
                  //

                  datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(int m = 1; m < n; m++)
                     {
                        macd[i+m]   = macd[i]   + (macd[i+n]   - macd[i]  ) * m/n;
                        signal[i+m] = signal[i] + (signal[i+n] - signal[i]) * m/n;
                        if (macduu[i] != EMPTY_VALUE) macduu[i+m] = macd[i+m];
                        if (macdud[i] != EMPTY_VALUE) macdud[i+m] = macd[i+m];
                        if (macddd[i] != EMPTY_VALUE) macddd[i+m] = macd[i+m];
                        if (macddu[i] != EMPTY_VALUE) macddu[i+m] = macd[i+m];
                     }               
            }
            return(0);
         }
         
   //
   //
   //
   //
   //
    
      for(i = limit; i>=0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            macd[i]   = iHull(price,FastPeriod,FastDivisor,i,0)-iHull(price,SlowPeriod,SlowDivisor,i,1);
            slope[i]  = slope[i+1];
            macduu[i] = EMPTY_VALUE;
            macdud[i] = EMPTY_VALUE;
            macddd[i] = EMPTY_VALUE;
            macddu[i] = EMPTY_VALUE;
               if (macd[i]>macd[i+1]) slope[i] =  1;
               if (macd[i]<macd[i+1]) slope[i] = -1;
               if (macd[i]>0)
                  if (slope[i] == 1)
                        macduu[i] = macd[i];
                  else  macdud[i] = macd[i];  
               if (macd[i]<0)
                  if (slope[i] == 1)
                        macddu[i] = macd[i];
                  else  macddd[i] = macd[i];  
            signal[i] = iHull(macd[i],SignalPeriod,SignalDivisor,i,2);
      }            
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workHull[][6];
double iHull(double price, double period, double divisor, int r, int instanceNo=0)
{
   if (ArrayRange(workHull,0)!= Bars) ArrayResize(workHull,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //

      int HmaPeriod  = MathMax(period,2);
      int HalfPeriod = MathFloor(HmaPeriod/divisor);
      int HullPeriod = MathFloor(MathSqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}